#include <ESP8266WiFi.h>

volatile bool got_frame = false;

void ICACHE_FLASH_ATTR callback(uint8_t *buffer, uint16_t length) {
	digitalWrite(LED_BUILTIN, LOW);

	got_frame = true;
}

os_timer_t channel_hop_timer;

void hop() {
	wifi_set_channel((rand() % 13) + 1);
}

void setup() {
	Serial.begin(115200);

	pinMode(LED_BUILTIN, OUTPUT);

	srand(analogRead(A0) ^ micros());

	delay(10);
	wifi_set_opmode(STATION_MODE);
	wifi_set_channel(1);
	wifi_promiscuous_enable(false);
	delay(10);
	wifi_set_promiscuous_rx_cb(callback);
	delay(10);
	wifi_promiscuous_enable(true);

	os_timer_disarm(&channel_hop_timer);
	os_timer_setfn(&channel_hop_timer, (os_timer_func_t *) hop, NULL);
	os_timer_arm(&channel_hop_timer, 250, 1);
}

void loop() {
	if (got_frame) {
		got_frame = false;

		delay(10);  

		digitalWrite(LED_BUILTIN, HIGH);
	}
}
